package org.zeroturnaround.javarebel.wicket;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class InjectorHolderCBP extends JavassistClassBytecodeProcessor {
	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass)
			throws Exception {

		cp.importPackage("org.zeroturnaround.javarebel");

		CtMethod setInjector = ctClass.getDeclaredMethod("setInjector");
		setInjector
				.insertAfter("ReloaderFactory.getInstance()." +
						            "addClassReloadListener((org.zeroturnaround.javarebel.ClassEventListener)injector);");
	}

}